import {
  THEME_SETTINGS,
  LOAD_DASHBOARD_STATS,
  START,
  SUCCESS,
  FAIL, SET_LANG
} from '../constants'

export default (settingsState = {
  showNotificationBar: false,
  language: 'en',
  dashboard: {
    dashboardStats: {
      enabled: false,
      loading: false,
      stats: []
    }
  },
  layout: {
    showHeader: true,
    showFooter: true,
    showSidebar: true,
    showBanner: true,
    sidebarPosition: 'left'
  },
  text: {
    footerText: ''
  }
}, action) => {
  const { type, response, error, lang } = action
  switch (type) {
    case THEME_SETTINGS + SUCCESS:
      return {...settingsState, ...response}

    case 'TOGGLE_NOTIFICATION_BAR':
      return {
        ...settingsState,
        showNotificationBar: !settingsState.showNotificationBar
      }

    case LOAD_DASHBOARD_STATS + START:
      return {
        ...settingsState,
        dashboard: {
          ...settingsState.dashboard,
          dashboardStats: {
            ...settingsState.dashboard.dashboardStats,
            loading: true
          }
        }
      }

    case LOAD_DASHBOARD_STATS + SUCCESS:
      return {
        ...settingsState,
        dashboard: {
          ...settingsState.dashboard,
          dashboardStats: {
            ...settingsState.dashboard.dashboardStats,
            stats: response,
            loading: false
          }
        }
      }

    case LOAD_DASHBOARD_STATS + FAIL:
      return {
        ...settingsState,
        dashboard: {
          ...settingsState.dashboard,
          dashboardStats: {
              ...settingsState.dashboard.dashboardStats,
              loading: false
          }
        }
      }

    case SET_LANG:
      return {
        ...settingsState,
        language: lang
      }
  }

  return settingsState
}